<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { init } from 'aos';

import {
  SupportCopy,
  SupportHero,
  SupportNote,
} from '~/components/support/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    SupportCopy,
    SupportHero,
    SupportNote,
  },
  async asyncData({ $content, error }) {
    try {
      const support = await $content('support/index').fetch();
      return { support };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).support, this.$route.path);
  },
  beforeMount() {
    init({
      once: true,
    });
  },
});
</script>

<template>
  <SlpContainer>
    <client-only>
      <SupportHero :data="support['support-hero'].data" />
      <SlpSideNavigation :data="support.side_menu">
        <template #footer>
          <div>
            <SlpTypography
              v-show="support.side_menu.hyperlinks.text"
              tag="div"
              variant="all-caps"
              class="nav-heading"
              >{{ support.side_menu.hyperlinks.text }}</SlpTypography
            >
            <SlpButton
              v-for="(button, buttonIndex) in support.side_menu.hyperlinks.data"
              :key="buttonIndex"
              class="hyperlinks"
              :variant="button.variant"
              :href="button.href"
              :data-ga-name="button.data_ga_name"
              :data-ga-location="button.data_ga_location"
              >{{ button.text }}
              <SlpIcon
                v-if="button.icon"
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </div>
        </template>
        <component
          :is="component.name"
          v-for="component in support.components"
          :key="component.name + Math.random()"
          :data="component.data"
        />
      </SlpSideNavigation>
    </client-only>
  </SlpContainer>
</template>
<style lang="scss" scoped>
.hyperlinks {
  font-size: $font-size-default;
  line-height: 20px;
  font-weight: $font-weight-normal;
  text-align: left !important;
}
.nav-heading {
  font-size: 12px;
  font-weight: $font-weight-bold;
  margin-bottom: $spacing-8;
}
</style>
